#!/usr/bin/python
"""
    Space Parcels -- introduction screen
    Copyright (C) 2005 Mathieu "Zig" Brethes <just.want.to.be@free.fr>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
"""
# Intro of the game SpaceParcels

import pygame, os.path
from pygame.locals import *
from sound import SoundEngine
import myglobals

def intro():
	DX = myglobals.DX
	DY = myglobals.DY
	screen = myglobals.screen
	background = myglobals.background
	mySound = myglobals.mySound

	theFont = pygame.font.Font("afont.ttf", 20)
	pygame.mouse.set_visible(0)
	
	# True: clear the screen before blitting
	TheImages = [("intro_00.png",[0,150], True), ("intro_01.png",[240,100], False), 
			("intro_02.png", [240,100], False), ("intro_03.png", [240,100], False),
			("intro_04.png", [240,100], False), ("intro_05.png", [240,100], False),
			("intro_06.png", [240,100], False), ("intro_07.png", [240,100], False),
			("intro_08.png", [0, 150], False), ("intro_09.png",[80,100], True),
			("intro_10.png", [100, 100], True), ("intro_11.png", [100, 100], True)]

	# True: shows the next image
	TheText = [("", False),
			("In A.D. 2101...", False),
			("War was beginning.", False),
			("", False),
			("", False),
			("Uh... Wait a minute, that's the wrong script.", False),
			("Let's start over again.", False),
			("In A.D. 2101...", False),
			("Well, by that time, you know, man discovered space travel and stuff.", False),
			("They move from planet to planet, create colonies, and do stuff humans do.", False),
			("", False),
			("", False),
			("Logistics quickly became a problem.", True),
			("", False),
			("", False),
			("Well,", True),
			("basically,", True),
			("It was hard to scale up", True),
			("The delivery of goods", True),
			("To the size of the universe.", True),
			("", True),
			("", True),
			("The \"Truck\" approach just isn't fast enough.", True),
			("", False),
			("", False),
			("", False),
			("In order to survive (and order things from the Internet),", False),
			("the human race had to design another solution.", False),
			("", False),
			("", False),
			("Several ideas were discussed.", True),
			("", False),
			("", False),
			("", False),
			("In the end, a young engineer made the following remark:", True),
			('"Hey, since we humans are so good at blowing stuff up,', False),
			('why don\'t we use space cannons to send parcels into space?"', True),
			("", False),
			("", False),
			('Several dozen beers later, everybody agreed.', False),
			("", False),
			('The space delivery network was born.', False),
			('', False),('', False),('', False)]

			
	indexImages = 0
	indexText   = 0
	genImg  = pygame.Surface([DX, DY])
	imgList = []
	txtList = []
	genImg.fill(0)
	curText = ""
	oldText = ""
	change = False
	mySound.playTune("menu.wav")
        C = pygame.time.Clock()
        C.tick()
	while indexText < len(TheText):
		pygame.event.pump()
		if pygame.event.peek([KEYDOWN,MOUSEBUTTONDOWN]):
			break
		veryOldText = oldText
		oldText = curText
		oldChange = change
		(curText, change) = TheText[indexText]
		indexText += 1

		# Switch images
		if oldChange:
			(imgname, coords, clear) = TheImages[indexImages]
			indexImages += 1
			img = pygame.image.load(os.path.join("media","images",imgname))
			if clear:
				for i in imgList:
					genImg.fill(0, i)
				imgList = []
			genImg.blit(img, coords)
			imgList.append(img.get_rect().move(coords[0], coords[1]))
		# general stuff
		vot = theFont.render(veryOldText, True, pygame.color.Color("gray"))
		ot  = theFont.render(oldText, True, pygame.color.Color("white"))
		ct  = theFont.render(curText, True, pygame.color.Color("gray"))

		# clear the oldies
		for i in txtList:
			genImg.fill(0, i)
		txtList = [vot.get_rect().move(40, 400), ot.get_rect().move(40, 420), ct.get_rect().move(40, 440)]
		
		# blit the news
		genImg.blit(vot, (40, 400))
		genImg.blit(ot,  (40, 420))
		genImg.blit(ct,  (40, 440))
		screen.blit(genImg, (0,0))
		pygame.display.flip()
		C.tick(0.75)
	
	# end:
	genImg.fill(0)
	screen.blit(genImg, (0,0))
	pygame.display.flip()
			
